Whamcloud - gitweb
LU-7110 tests: sanity-hsm.sh can erase all files on filesystem
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
index d7eab96..9f8ec9c 100755 (executable)
@@ -24,6 +24,7 @@ init_logging
 
 MULTIOP=${MULTIOP:-multiop}
 OPENFILE=${OPENFILE:-openfile}
+MMAP_CAT=${MMAP_CAT:-mmap_cat}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
@@ -102,7 +103,16 @@ init_agt_vars() {
        export HSMTOOL_EVENT_FIFO=${HSMTOOL_EVENT_FIFO:=""}
        export HSMTOOL_TESTDIR
        export HSMTOOL_BASE=$(basename "$HSMTOOL" | cut -f1 -d" ")
+       # $hsm_root/$HSMTMP Makes $hsm_root dir path less generic to ensure
+       # rm -rf $hsm_root/* is safe even if $hsm_root becomes unset to avoid
+       # deleting everything in filesystem, independent of any copytool.
+       export HSMTMP=${HSMTMP:-"shsm"}
+
        HSM_ARCHIVE=$(copytool_device $SINGLEAGT)
+
+       [ -z "${HSM_ARCHIVE// /}" ] && error "HSM_ARCHIVE is empty!"
+       HSM_ARCHIVE=$HSM_ARCHIVE/$HSMTMP
+
        HSM_ARCHIVE_NUMBER=2
 
        # The test only support up to 10 MDTs
@@ -144,15 +154,40 @@ get_mdt_devices() {
 }
 
 search_copytools() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
-       do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       do_nodesv $hosts "pgrep -x $HSMTOOL_BASE"
 }
 
-search_and_kill_copytool() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+kill_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
 
-       echo "Killing existing copytools on $agents"
-       do_nodesv $agents "killall -q $HSMTOOL_BASE" || true
+       echo "Killing existing copytools on $hosts"
+       do_nodesv $hosts "killall -q $HSMTOOL_BASE" || true
+}
+
+wait_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       local wait_timeout=200
+       local wait_start=$SECONDS
+       local wait_end=$((wait_start + wait_timeout))
+
+       while ((SECONDS < wait_end)); do
+               sleep 2
+               if ! search_copytools $hosts; then
+                       echo "copytools stopped in $((SECONDS - wait_start))s"
+                       return 0
+               fi
+
+               echo "copytools still running on $hosts"
+       done
+
+       # try to dump Copytool's stack
+       do_nodesv $hosts "echo 1 >/proc/sys/kernel/sysrq ; " \
+                        "echo t >/proc/sysrq-trigger"
+
+       echo "copytools failed to stop in ${wait_timeout}s"
+
+       return 1
 }
 
 copytool_monitor_setup() {
@@ -218,6 +253,9 @@ copytool_setup() {
        local lustre_mntpnt=${2:-${MOUNT2:-$MOUNT}}
        local arc_id=$3
        local hsm_root=${4:-$(copytool_device $facet)}
+
+       [ -z "${hsm_root// /}" ] && error "copytool_setup: hsm_root empty!"
+
        local agent=$(facet_active_host $facet)
 
        if [[ -z "$arc_id" ]] &&
@@ -228,14 +266,16 @@ copytool_setup() {
 
        if $HSM_ARCHIVE_PURGE; then
                echo "Purging archive on $agent"
-               do_facet $facet "rm -rf $hsm_root/*"
+               do_facet $facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 
        echo "Starting copytool $facet on $agent"
-       do_facet $facet "mkdir -p $hsm_root" || error "mkdir '$hsm_root' failed"
+       do_facet $facet "mkdir -p $hsm_root/$HSMTMP/" ||
+                       error "mkdir '$hsm_root/$HSMTMP' failed"
        # bandwidth is limited to 1MB/s so the copy time is known and
        # independent of hardware
-       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon --hsm-root $hsm_root"
+       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon"
+       cmd+=" --hsm-root $hsm_root/$HSMTMP"
        [[ -z "$arc_id" ]] || cmd+=" --archive $arc_id"
        [[ -z "$HSMTOOL_UPDATE_INTERVAL" ]] ||
                cmd+=" --update-interval $HSMTOOL_UPDATE_INTERVAL"
@@ -272,54 +312,61 @@ get_copytool_event_log() {
 
 copytool_cleanup() {
        trap - EXIT
-       local facet=$SINGLEAGT
-       local agents=${1:-$(facet_active_host $facet)}
-       local mdtno
-       local idx
-       local oldstate
-       local mdt_hsmctrl
-       local hsm_root=$(copytool_device $facet)
-       local end_wait=$(( SECONDS + TIMEOUT ))
+       local agt_facet=$SINGLEAGT
+       local agt_hosts=${1:-$(facet_active_host $agt_facet)}
+       local hsm_root=$(copytool_device $agt_facet)
 
-       do_nodesv $agents "pkill -INT -x $HSMTOOL_BASE" || return 0
+       [ -z "${hsm_root// /}" ] && error "copytool_cleanup: hsm_root empty!"
 
-       while (( SECONDS < end_wait )); do
-               sleep 2
-               do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
-               if [ $? -ne 0 ]; then
-                       echo "Copytool is stopped on $agents"
-                       break
-               fi
-               echo "Copytool still running on $agents"
+       local i
+       local facet
+       local param
+       local -a state
+
+       kill_copytools $agt_hosts
+       wait_copytools $agt_hosts || error "copytools failed to stop"
+
+       # Clean all CDTs orphans requests from previous tests that
+       # would otherwise need to timeout to clear.
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+               state[$i]=$(do_facet $facet "$LCTL get_param -n $param")
+
+               # Skip already stopping or stopped CDTs.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               do_facet $facet "$LCTL set_param $param=shutdown"
        done
-       if do_nodesv $agents "pgrep -x $HSMTOOL_BASE"; then
-               error "Copytool failed to stop in ${TIMEOUT}s ..."
-       else
-               echo "Copytool has stopped in " \
-                    "$((TIMEOUT - (end_wait - SECONDS)))s."
-       fi
 
-       # clean all CDTs orphans requests from previous tests
-       # that would otherwise need to timeout to clear.
-       for mdtno in $(seq 1 $MDSCOUNT); do
-               idx=$(($mdtno - 1))
-               mdt_hsmctrl="mdt.$FSNAME-MDT000${idx}.hsm_control"
-               oldstate=$(do_facet mds${mdtno} "$LCTL get_param -n " \
-                                  "$mdt_hsmctrl")
-               # skip already stop[ed,ing] CDTs
-               echo $oldstate | grep stop && continue
-
-               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=shutdown"
-               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
-                       "stopped" 20 ||
-                       error "mds${mdtno} cdt state is not stopped"
-               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=$oldstate"
-               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
-                       "$oldstate" 20 ||
-                       error "mds${mdtno} cdt state is not $oldstate"
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               # Only check and restore CDTs that we stopped in the first loop.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+
+               wait_result $facet "$LCTL get_param -n $param" stopped 20 ||
+                       error "$facet CDT state is not stopped"
+
+               # Restore old CDT state.
+               do_facet $facet "$LCTL set_param $param=${state[$i]}"
+       done
+
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               # Only check CDTs that we stopped in the first loop.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+
+               # Check that the old CDT state was restored.
+               wait_result $facet "$LCTL get_param -n $param" "${state[$i]}" \
+                       20 || error "$facet CDT state is not '${state[$i]}'"
        done
-       if do_facet $facet "df $hsm_root" >/dev/null 2>&1 ; then
-               do_facet $facet "rm -rf $hsm_root/*"
+
+       if do_facet $agt_facet "df $hsm_root" >/dev/null 2>&1 ; then
+               do_facet $agt_facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 }
 
@@ -484,6 +531,13 @@ cdt_clear_mount_state() {
 
 cdt_set_mount_state() {
        mdts_set_param "-P" hsm_control "$1"
+       # set_param -P is asynchronous operation and could race with set_param.
+       # In such case configs could be retrieved and applied at mgc after
+       # set_param -P completion. Sleep here to avoid race with set_param.
+       # We need at least 20 seconds. 10 for mgc_requeue_thread to wake up
+       # MGC_TIMEOUT_MIN_SECONDS + MGC_TIMEOUT_RAND_CENTISEC(5 + 5)
+       # and 10 seconds to retrieve config from server.
+       sleep 20
 }
 
 cdt_check_state() {
@@ -757,14 +811,14 @@ parse_json_event() {
        echo $raw_event | python -c "$json_parser"
 }
 
-# populate MDT device array
-get_mdt_devices
-
 # initiate variables
 init_agt_vars
 
+# populate MDT device array
+get_mdt_devices
+
 # cleanup from previous bad setup
-search_and_kill_copytool
+kill_copytools
 
 # for recovery tests, coordinator needs to be started at mount
 # so force it
@@ -817,6 +871,23 @@ test_1() {
 }
 run_test 1 "lfs hsm flags root/non-root access"
 
+test_1a() {
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(make_small $f)
+
+       $LFS hsm_archive $f || error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       # Release and check states
+       $LFS hsm_release $f || error "could not release file"
+       echo -n "Verifying released state: "
+       check_hsm_flags $f "0x0000000d"
+
+       $MMAP_CAT $f > /dev/null || error "failed mmap & cat release file"
+}
+run_test 1a "mmap & cat a HSM released file"
+
 test_2() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
@@ -1424,6 +1495,8 @@ cleanup_test_12q() {
 }
 
 test_12q() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.58) ] &&
+               skip "need MDS version at least 2.7.58" && return 0
 
        zconf_mount $(facet_host $SINGLEAGT) $MOUNT3 ||
                error "cannot mount $MOUNT3 on $SINGLEAGT"
@@ -1445,9 +1518,8 @@ test_12q() {
        $LFS hsm_release $f || error "could not release file"
        check_hsm_flags $f "0x0000000d"
 
-       search_and_kill_copytool
-       sleep 5
-       search_copytools && error "Copytool should have stopped"
+       kill_copytools
+       wait_copytools || error "copytool failed to stop"
 
        cat $f > /dev/null &
 
@@ -2094,7 +2166,9 @@ test_24e() {
        $LFS hsm_archive $f || error "cannot archive $f"
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f || error "cannot release $f"
-       sleep 5
+       while ! $LFS hsm_state $f | grep released; do
+               sleep 1
+       done
 
        tar -cf $TMP/$tfile.tar $DIR/$tdir || error "cannot tar $DIR/$tdir"
 
@@ -2102,6 +2176,33 @@ test_24e() {
 }
 run_test 24e "tar succeeds on HSM released files" # LU-6213
 
+test_24f() {
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir/d1
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+       sum0=$(md5sum $f)
+       echo $sum0
+       $LFS hsm_archive -a $HSM_ARCHIVE_NUMBER $f ||
+               error "hsm_archive failed"
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f || error "cannot release $f"
+       tar --xattrs -cvf $f.tar -C $DIR/$tdir $tfile
+       rm -f $f
+       sync
+       tar --xattrs -xvf $f.tar -C $DIR/$tdir ||
+               error "Can not recover the tar contents"
+       sum1=$(md5sum $f)
+       echo "Sum0 = $sum0, sum1 = $sum1"
+       [ "$sum0" == "$sum1" ] || error "md5sum mismatch for '$tfile'"
+
+       copytool_cleanup
+}
+run_test 24f "root can archive, release, and restore tar files"
+
 test_25a() {
        # test needs a running copytool
        copytool_setup
@@ -2996,6 +3097,23 @@ test_58() {
 }
 run_test 58 "Truncate a released file will trigger restore"
 
+test_59() {
+       local fid
+       local server_version=$(lustre_version_code $SINGLEMDS)
+       [[ $server_version -lt $(version_code 2.7.63) ]] &&
+               skip "Need MDS version at least 2.7.63" && return
+
+       copytool_setup
+       $MCREATE $DIR/$tfile || error "mcreate failed"
+       $TRUNCATE $DIR/$tfile 42 || error "truncate failed"
+       $LFS hsm_archive $DIR/$tfile || error "archive request failed"
+       fid=$(path2fid $DIR/$tfile)
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $DIR/$tfile || error "release failed"
+       copytool_cleanup
+}
+run_test 59 "Release stripeless file with non-zero size"
+
 test_60() {
        # This test validates the fix for LU-4512. Ensure that the -u
        # option changes the progress reporting interval from the
@@ -3061,7 +3179,7 @@ test_60() {
        local elapsed=$((finish_at - start_at))
 
        # Ensure that the progress update occurred within the expected window.
-       if [ $elapsed -lt $interval ]; then
+       if [ $elapsed -lt $((interval - 1)) ]; then
                error "Expected progress update after at least $interval seconds"
        fi
 
@@ -3741,6 +3859,8 @@ test_200() {
        # test with cdt on is made in test_221
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       # wait archive to register at CDT
+       wait_request_state $fid ARCHIVE WAITING
        $LFS hsm_cancel $f
        cdt_enable
        wait_request_state $fid ARCHIVE CANCELED
@@ -3763,6 +3883,8 @@ test_201() {
        # test with cdt on is made in test_222
        cdt_disable
        $LFS hsm_restore $f
+       # wait restore to register at CDT
+       wait_request_state $fid RESTORE WAITING
        $LFS hsm_cancel $f
        cdt_enable
        wait_request_state $fid RESTORE CANCELED
@@ -3787,6 +3909,8 @@ test_202() {
 
        cdt_disable
        $LFS hsm_remove $f
+       # wait remove to register at CDT
+       wait_request_state $fid REMOVE WAITING
        $LFS hsm_cancel $f
        cdt_enable
        wait_request_state $fid REMOVE CANCELED
@@ -4512,6 +4636,66 @@ test_405() {
 }
 run_test 405 "archive and release under striped directory"
 
+test_406() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+               skip "need MDS version at least 2.7.64" && return 0
+
+       local fid
+       local mdt_index
+
+       copytool_setup
+       mkdir -p $DIR/$tdir
+       fid=$(make_small $DIR/$tdir/$tfile)
+       echo "old fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED
+       $LFS hsm_release $DIR/$tdir/$tfile
+
+       # Should migrate $tdir but not $tfile.
+       $LFS mv -M1 $DIR/$tdir &&
+               error "migrating HSM an archived file should fail"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED
+
+       $LFS hsm_remove $DIR/$tdir/$tfile
+       wait_request_state "$fid" REMOVE SUCCEED
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       $LFS mv -M1 $DIR/$tdir ||
+               error "cannot complete migration after HSM remove"
+
+       mdt_index=$($LFS getstripe -M $DIR/$tdir)
+       if ((mdt_index != 1)); then
+               error "expected MDT index 1, got $mdt_index"
+       fi
+
+       # Refresh fid after migration.
+       fid=$(path2fid $DIR/$tdir/$tfile)
+       echo "new fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED 1
+
+       lctl set_param debug=+trace
+       $LFS hsm_release $DIR/$tdir/$tfile ||
+               error "cannot release $DIR/$tdir/$tfile"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED 1
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       copytool_cleanup
+}
+run_test 406 "attempting to migrate HSM archived files is safe"
+
 test_500()
 {
        [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.92) ] &&